#version 300 es
precision highp float;
precision highp int;

uniform vec4 u_DirLightsDirection[3];
uniform vec4 u_DirLightsColor[3];
uniform float u_DirLightsIntensity[3];
uniform float u_DirLightsEnabled[3];
uniform vec4 u_PointLightsPosition[2];
uniform vec4 u_PointLightsColor[2];
uniform float u_PointLightsIntensity[2];
uniform float u_PointLightsAttenRangeInv[2];
uniform float u_PointLightsEnabled[2];
uniform vec4 u_SpotLightsDirection[2];
uniform vec4 u_SpotLightsPosition[2];
uniform vec4 u_SpotLightsColor[2];
uniform float u_SpotLightsIntensity[2];
uniform float u_SpotLightsInnerAngleCos[2];
uniform float u_SpotLightsOuterAngleCos[2];
uniform float u_SpotLightsAttenRangeInv[2];
uniform float u_SpotLightsEnabled[2];
uniform vec4 u_WorldSpaceCameraPos;
uniform vec4 u_AlbedoColor;
uniform vec4 u_SpecularColor;
uniform float u_SpecularIntensity;
uniform float u_SpecularPower;

in vec3 g_vary_WorldPosition;
in vec3 g_vary_WorldNormal;
layout(location = 0) out vec4 o_fragColor;

void main()
{
    vec3 _717 = normalize(g_vary_WorldNormal);
    vec3 _734 = normalize(u_WorldSpaceCameraPos.xyz - g_vary_WorldPosition);
    vec4 _2705 = vec4(u_SpecularColor.xyz * u_SpecularIntensity, u_SpecularPower);
    vec3 _859 = normalize(-u_DirLightsDirection[0].xyz);
    bool _1022 = u_DirLightsEnabled[0] > 0.5;
    vec3 _2685;
    if (_1022)
    {
        _2685 = ((((u_AlbedoColor.xyz * (dot(_717, _859) * 0.5 + 0.5)) + (_2705.xyz * pow(clamp(dot(_717, normalize(_734 + _859)), 0.0, 1.0), u_SpecularPower))) * u_DirLightsIntensity[0]) * u_DirLightsColor[0].xyz) * u_DirLightsEnabled[0];
    }
    else
    {
        _2685 = vec3(0.0);
    }
    bool _1043 = u_DirLightsEnabled[1] > 0.5;
    vec3 _2686;
    if (_1043)
    {
        vec3 _1048 = max(normalize(-u_DirLightsDirection[1].xyz), vec3(0.001000000047497451305389404296875));
        _2686 = _2685 + (((((u_AlbedoColor.xyz * (dot(_717, _1048) * 0.5 + 0.5)) + (_2705.xyz * pow(clamp(dot(_717, normalize(_734 + _1048)), 0.0, 1.0), u_SpecularPower))) * u_DirLightsIntensity[1]) * u_DirLightsColor[1].xyz) * u_DirLightsEnabled[1]);
    }
    else
    {
        _2686 = _2685;
    }
    vec3 _2689;
    if (_1022)
    {
        vec3 _1187 = (u_PointLightsPosition[0].xyz - g_vary_WorldPosition) * u_PointLightsAttenRangeInv[0];
        float _1189 = length(_1187);
        vec3 _1194 = _1187 / vec3(max(_1189, 0.001000000047497451305389404296875));
        float _1200 = dot(_717, _1194);
        _2689 = (((((u_AlbedoColor.xyz * (_1200 * 0.5 + 0.5)) + (_2705.xyz * pow(clamp(dot(_717, normalize(_734 + _1194)), 0.0, 1.0), u_SpecularPower))) * u_PointLightsIntensity[0]) * u_PointLightsColor[0].xyz) * (((pow(clamp(1.0 - pow(_1189, 4.0), 0.0, 1.0), 2.0) * 0.25) * (pow(_1189, 2.0) + 1.0)) * max(0.0, _1200))) * u_PointLightsEnabled[0];
    }
    else
    {
        _2689 = vec3(0.0);
    }
    vec3 _2690;
    if (_1043)
    {
        vec3 _1243 = (u_PointLightsPosition[1].xyz - g_vary_WorldPosition) * u_PointLightsAttenRangeInv[1];
        float _1245 = length(_1243);
        vec3 _1250 = _1243 / vec3(max(_1245, 0.001000000047497451305389404296875));
        float _1256 = dot(_717, _1250);
        _2690 = _2689 + ((((((u_AlbedoColor.xyz * (_1256 * 0.5 + 0.5)) + (_2705.xyz * pow(clamp(dot(_717, normalize(_734 + _1250)), 0.0, 1.0), u_SpecularPower))) * u_PointLightsIntensity[1]) * u_PointLightsColor[1].xyz) * (((pow(clamp(1.0 - pow(_1245, 4.0), 0.0, 1.0), 2.0) * 0.25) * (pow(_1245, 2.0) + 1.0)) * max(0.0, _1256))) * u_PointLightsEnabled[1]);
    }
    else
    {
        _2690 = _2689;
    }
    vec3 _2693;
    if (_1022)
    {
        vec3 _1413 = (u_SpotLightsPosition[0].xyz - g_vary_WorldPosition) * u_SpotLightsAttenRangeInv[0];
        float _1415 = length(_1413);
        vec3 _1420 = _1413 / vec3(max(_1415, 0.00999999977648258209228515625));
        float _1426 = dot(_717, _1420);
        _2693 = (((((u_AlbedoColor.xyz * (_1426 * 0.5 + 0.5)) + (_2705.xyz * pow(clamp(dot(_717, normalize(_734 + _1420)), 0.0, 1.0), u_SpecularPower))) * u_SpotLightsIntensity[0]) * u_SpotLightsColor[0].xyz) * ((((pow(clamp(1.0 - pow(_1415, 4.0), 0.0, 1.0), 2.0) * 0.25) * (pow(_1415, 2.0) + 1.0)) * max(0.0, _1426)) * smoothstep(u_SpotLightsOuterAngleCos[0], u_SpotLightsInnerAngleCos[0], max(0.0, dot(_1420, normalize(-u_SpotLightsDirection[0].xyz)))))) * u_SpotLightsEnabled[0];
    }
    else
    {
        _2693 = vec3(0.0);
    }
    vec3 _2694;
    if (_1043)
    {
        vec3 _1483 = (u_SpotLightsPosition[1].xyz - g_vary_WorldPosition) * u_SpotLightsAttenRangeInv[1];
        float _1485 = length(_1483);
        vec3 _1490 = _1483 / vec3(max(_1485, 0.00999999977648258209228515625));
        float _1496 = dot(_717, _1490);
        _2694 = _2693 + ((((((u_AlbedoColor.xyz * (_1496 * 0.5 + 0.5)) + (_2705.xyz * pow(clamp(dot(_717, normalize(_734 + _1490)), 0.0, 1.0), u_SpecularPower))) * u_SpotLightsIntensity[1]) * u_SpotLightsColor[1].xyz) * ((((pow(clamp(1.0 - pow(_1485, 4.0), 0.0, 1.0), 2.0) * 0.25) * (pow(_1485, 2.0) + 1.0)) * max(0.0, _1496)) * smoothstep(u_SpotLightsOuterAngleCos[1], u_SpotLightsInnerAngleCos[1], max(0.0, dot(_1490, normalize(-u_SpotLightsDirection[1].xyz)))))) * u_SpotLightsEnabled[1]);
    }
    else
    {
        _2694 = _2693;
    }
    o_fragColor = vec4(pow((_2686 + _2690) + _2694, vec3(0.454545438289642333984375)), u_AlbedoColor.w);
}

